type token =
  | IDENTIFIER of (string)
  | STRING_LITERAL of (string)
  | TYPENAME of (string)
  | CONSTANT of (Clogic.constant)
  | LPAR
  | RPAR
  | IF
  | ELSE
  | COLON
  | COLONCOLON
  | DOT
  | DOTDOT
  | AMP
  | INT
  | FLOAT
  | LT
  | GT
  | LE
  | GE
  | EQ
  | NE
  | COMMA
  | ARROW
  | EQUAL
  | FORALL
  | EXISTS
  | IFF
  | IMPLIES
  | AND
  | OR
  | NOT
  | TRUE
  | FALSE
  | OLD
  | AT
  | RESULT
  | BLOCK_LENGTH
  | BASE_ADDR
  | VALID
  | VALID_INDEX
  | VALID_RANGE
  | FRESH
  | THEN
  | QUESTION
  | MINUS
  | PLUS
  | STAR
  | SLASH
  | PERCENT
  | LSQUARE
  | RSQUARE
  | EOF
  | INVARIANT
  | VARIANT
  | DECREASES
  | FOR
  | LABEL
  | ASSERT
  | SEMICOLON
  | NULL
  | REQUIRES
  | ENSURES
  | ASSIGNS
  | LOOP_ASSIGNS
  | NOTHING
  | READS
  | LOGIC
  | PREDICATE
  | AXIOM
  | LBRACE
  | RBRACE
  | GHOST
  | SET
  | VOID
  | CHAR
  | SIGNED
  | UNSIGNED
  | SHORT
  | LONG
  | DOUBLE
  | STRUCT
  | ENUM
  | UNION

open Parsing;;
# 20 "c/clparser.mly"

  open Cast
  open Clogic

  let loc () = (symbol_start (), symbol_end ())
  let loc_i i = (rhs_start i, rhs_end i)
  let info x = { Clogic.lexpr_node = x; lexpr_loc = loc () }

  type ghost_decl =
    | Dsimple 
    | Darray of ghost_decl * lexpr option

  let ghost ty (id,gd,cinit) = 
    match gd with
      | Dsimple -> LDghost(ty,id,cinit)
      | Darray _ -> assert false

    
# 107 "c/clparser.ml"
let yytransl_const = [|
  261 (* LPAR *);
  262 (* RPAR *);
  263 (* IF *);
  264 (* ELSE *);
  265 (* COLON *);
  266 (* COLONCOLON *);
  267 (* DOT *);
  268 (* DOTDOT *);
  269 (* AMP *);
  270 (* INT *);
  271 (* FLOAT *);
  272 (* LT *);
  273 (* GT *);
  274 (* LE *);
  275 (* GE *);
  276 (* EQ *);
  277 (* NE *);
  278 (* COMMA *);
  279 (* ARROW *);
  280 (* EQUAL *);
  281 (* FORALL *);
  282 (* EXISTS *);
  283 (* IFF *);
  284 (* IMPLIES *);
  285 (* AND *);
  286 (* OR *);
  287 (* NOT *);
  288 (* TRUE *);
  289 (* FALSE *);
  290 (* OLD *);
  291 (* AT *);
  292 (* RESULT *);
  293 (* BLOCK_LENGTH *);
  294 (* BASE_ADDR *);
  295 (* VALID *);
  296 (* VALID_INDEX *);
  297 (* VALID_RANGE *);
  298 (* FRESH *);
  299 (* THEN *);
  300 (* QUESTION *);
  301 (* MINUS *);
  302 (* PLUS *);
  303 (* STAR *);
  304 (* SLASH *);
  305 (* PERCENT *);
  306 (* LSQUARE *);
  307 (* RSQUARE *);
    0 (* EOF *);
  308 (* INVARIANT *);
  309 (* VARIANT *);
  310 (* DECREASES *);
  311 (* FOR *);
  312 (* LABEL *);
  313 (* ASSERT *);
  314 (* SEMICOLON *);
  315 (* NULL *);
  316 (* REQUIRES *);
  317 (* ENSURES *);
  318 (* ASSIGNS *);
  319 (* LOOP_ASSIGNS *);
  320 (* NOTHING *);
  321 (* READS *);
  322 (* LOGIC *);
  323 (* PREDICATE *);
  324 (* AXIOM *);
  325 (* LBRACE *);
  326 (* RBRACE *);
  327 (* GHOST *);
  328 (* SET *);
  329 (* VOID *);
  330 (* CHAR *);
  331 (* SIGNED *);
  332 (* UNSIGNED *);
  333 (* SHORT *);
  334 (* LONG *);
  335 (* DOUBLE *);
  336 (* STRUCT *);
  337 (* ENUM *);
  338 (* UNION *);
    0|]

let yytransl_block = [|
  257 (* IDENTIFIER *);
  258 (* STRING_LITERAL *);
  259 (* TYPENAME *);
  260 (* CONSTANT *);
    0|]

let yylhs = "\255\255\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\002\000\002\000\005\000\005\000\008\000\008\000\008\000\007\000\
\007\000\007\000\007\000\007\000\007\000\007\000\007\000\007\000\
\007\000\007\000\007\000\007\000\007\000\007\000\007\000\007\000\
\007\000\007\000\007\000\007\000\009\000\009\000\003\000\003\000\
\003\000\003\000\003\000\003\000\006\000\006\000\010\000\010\000\
\011\000\011\000\012\000\012\000\013\000\016\000\016\000\016\000\
\016\000\017\000\019\000\019\000\015\000\015\000\001\000\021\000\
\021\000\021\000\021\000\021\000\021\000\021\000\014\000\014\000\
\014\000\018\000\018\000\020\000\020\000\024\000\024\000\025\000\
\022\000\022\000\022\000\022\000\022\000\022\000\022\000\023\000\
\026\000\026\000\004\000\004\000\028\000\028\000\027\000\027\000\
\029\000\029\000\030\000\032\000\032\000\032\000\031\000\031\000\
\031\000\033\000\033\000\000\000"

let yylen = "\002\000\
\003\000\003\000\003\000\003\000\002\000\001\000\001\000\003\000\
\006\000\004\000\004\000\004\000\006\000\008\000\004\000\001\000\
\001\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\004\000\006\000\002\000\002\000\002\000\002\000\005\000\004\000\
\006\000\004\000\004\000\001\000\003\000\001\000\004\000\004\000\
\004\000\003\000\000\000\001\000\001\000\002\000\001\000\001\000\
\001\000\002\000\002\000\002\000\001\000\002\000\002\000\001\000\
\002\000\002\000\001\000\002\000\003\000\002\000\003\000\001\000\
\001\000\002\000\001\000\002\000\001\000\002\000\001\000\001\000\
\001\000\001\000\001\000\001\000\000\000\001\000\001\000\003\000\
\000\000\002\000\000\000\002\000\004\000\003\000\002\000\002\000\
\001\000\002\000\004\000\002\000\000\000\002\000\002\000\001\000\
\001\000\001\000\001\000\002\000\002\000\004\000\000\000\002\000\
\002\000\000\000\001\000\002\000\002\000\001\000\003\000\001\000\
\006\000\008\000\005\000\007\000\008\000\004\000\004\000\003\000\
\000\000\001\000\001\000\003\000\002\000\004\000\001\000\003\000\
\001\000\003\000\001\000\001\000\004\000\003\000\001\000\003\000\
\004\000\001\000\003\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\140\000\000\000\098\000\099\000\
\000\000\000\000\000\000\000\000\096\000\097\000\000\000\017\000\
\000\000\000\000\000\000\000\000\000\000\000\000\006\000\007\000\
\000\000\000\000\036\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\016\000\000\000\101\000\000\000\
\000\000\000\000\109\000\000\000\108\000\000\000\000\000\067\000\
\053\000\064\000\048\000\049\000\000\000\000\000\056\000\000\000\
\065\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\107\000\000\000\087\000\095\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\071\000\072\000\
\073\000\074\000\075\000\076\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\069\000\000\000\052\000\050\000\055\000\000\000\
\054\000\051\000\057\000\000\000\062\000\066\000\068\000\000\000\
\000\000\000\000\132\000\000\000\127\000\000\000\000\000\000\000\
\105\000\104\000\000\000\000\000\086\000\000\000\000\000\000\000\
\078\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\024\000\023\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\111\000\070\000\061\000\063\000\000\000\122\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\085\000\
\000\000\000\000\039\000\000\000\000\000\000\000\000\000\000\000\
\124\000\000\000\032\000\000\000\035\000\034\000\012\000\000\000\
\000\000\015\000\000\000\025\000\000\000\000\000\000\000\128\000\
\000\000\000\000\130\000\134\000\000\000\094\000\091\000\080\000\
\000\000\126\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\138\000\000\000\133\000\000\000\033\000\
\013\000\000\000\026\000\000\000\116\000\000\000\000\000\136\000\
\000\000\114\000\117\000\137\000\139\000\014\000"

let yydgoto = "\002\000\
\013\000\052\000\121\000\191\000\184\000\152\000\066\000\087\000\
\124\000\153\000\014\000\148\000\015\000\073\000\200\000\016\000\
\017\000\018\000\077\000\019\000\020\000\021\000\022\000\053\000\
\054\000\192\000\140\000\088\000\141\000\142\000\227\000\143\000\
\245\000"

let yysindex = "\035\000\
\034\005\000\000\215\005\038\255\006\006\006\006\028\005\039\255\
\043\255\048\255\039\255\050\255\000\000\246\254\000\000\000\000\
\248\254\003\255\000\000\059\000\000\000\000\000\012\255\000\000\
\062\255\006\006\006\006\039\255\039\255\006\006\000\000\000\000\
\055\255\057\255\000\000\068\255\074\255\081\255\084\255\085\255\
\087\255\006\006\006\006\006\006\000\000\039\009\000\000\020\255\
\039\009\039\009\000\000\039\009\000\000\083\255\059\255\000\000\
\000\000\000\000\000\000\000\000\004\255\006\255\000\000\225\254\
\000\000\063\255\110\255\119\255\117\255\126\255\104\255\120\005\
\069\255\003\255\000\000\006\006\000\000\000\000\006\006\006\006\
\006\006\208\003\252\254\055\008\035\255\071\255\132\255\112\255\
\089\255\093\009\006\006\006\006\006\006\006\006\006\006\006\006\
\006\006\006\006\035\255\035\255\035\255\141\255\000\000\000\000\
\000\000\000\000\000\000\000\000\144\255\006\006\006\006\006\006\
\006\006\006\006\006\006\006\006\006\006\006\006\006\006\006\006\
\006\006\006\006\000\000\101\255\000\000\000\000\000\000\088\255\
\000\000\000\000\000\000\090\255\000\000\000\000\000\000\156\255\
\039\255\006\006\000\000\140\255\000\000\143\255\121\255\006\006\
\000\000\000\000\006\006\120\255\000\000\037\004\095\008\170\255\
\000\000\039\009\039\009\053\006\006\006\006\006\006\006\128\255\
\039\255\006\006\090\006\135\008\135\006\180\006\225\006\175\008\
\215\008\014\007\000\000\000\000\039\009\039\009\093\009\079\009\
\189\007\244\255\244\255\035\255\035\255\035\255\229\007\171\255\
\212\255\000\000\000\000\000\000\000\000\039\255\000\000\176\255\
\039\009\126\255\168\255\167\005\039\009\039\009\003\255\000\000\
\183\255\006\006\000\000\035\255\035\255\147\007\039\009\134\255\
\000\000\039\009\000\000\185\255\000\000\000\000\000\000\006\006\
\006\006\000\000\006\006\000\000\006\006\186\255\214\254\000\000\
\168\255\039\009\000\000\000\000\014\008\000\000\000\000\000\000\
\006\006\000\000\190\255\059\007\255\008\093\009\039\009\138\255\
\125\255\006\006\006\006\000\000\243\254\000\000\093\009\000\000\
\000\000\006\006\000\000\006\006\000\000\201\255\118\255\000\000\
\104\007\000\000\000\000\000\000\000\000\000\000"

let yyrindex = "\000\000\
\032\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\038\000\000\000\000\000\
\008\000\000\000\012\000\000\000\000\000\000\000\149\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\005\000\000\000\001\000\
\191\000\041\000\000\000\091\000\000\000\064\000\194\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\023\255\
\000\000\038\255\000\000\000\000\000\000\000\000\000\000\000\000\
\003\000\197\000\000\000\000\000\000\000\000\000\192\255\000\000\
\000\000\000\000\000\000\000\000\120\000\000\000\000\000\010\255\
\000\000\031\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\179\000\238\000\041\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\199\255\
\000\000\000\000\000\000\215\255\000\000\000\000\000\000\025\255\
\000\000\000\000\000\000\027\255\000\000\000\000\000\000\000\000\
\219\255\000\000\000\000\226\000\000\000\011\000\010\000\000\000\
\000\000\000\000\000\000\232\000\000\000\233\000\228\255\000\000\
\000\000\236\000\008\004\061\000\000\000\000\000\000\000\013\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\068\004\096\004\061\003\238\003\
\000\000\139\002\198\002\100\001\159\001\218\001\227\255\000\000\
\001\003\000\000\000\000\000\000\000\000\219\255\000\000\000\000\
\240\000\000\000\000\000\000\000\241\000\006\000\000\000\000\000\
\000\000\000\000\000\000\021\002\080\002\000\000\134\004\000\000\
\000\000\156\004\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\191\255\000\000\243\000\000\000\
\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\120\003\193\255\000\000\
\252\000\000\000\000\000\000\000\000\000\000\000\179\003\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\149\005\000\000\241\255\033\000\000\000\228\000\026\000\
\000\000\054\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\247\000\189\255\253\000\000\000\000\000\000\000\184\255\
\000\000\082\000\000\000\000\000\087\000\000\000\046\255\000\000\
\000\000"

let yytablesize = 2703
let yytable = "\146\000\
\038\000\157\000\083\000\135\000\090\000\084\000\149\000\106\000\
\255\000\131\000\129\000\089\000\086\000\089\000\244\000\123\000\
\079\000\125\000\125\000\129\000\080\000\081\000\242\000\059\000\
\079\000\058\000\243\000\060\000\059\000\081\000\058\000\081\000\
\060\000\067\000\125\000\001\000\070\000\103\000\047\000\055\000\
\082\000\056\000\135\000\068\000\005\001\102\000\133\000\134\000\
\069\000\186\000\071\000\072\000\057\000\058\000\007\000\076\000\
\000\001\109\000\078\000\091\000\037\000\092\000\048\000\110\000\
\056\000\024\000\025\000\123\000\026\000\059\000\125\000\058\000\
\093\000\060\000\027\000\057\000\058\000\126\000\094\000\130\000\
\127\000\128\000\131\000\132\000\120\000\095\000\028\000\029\000\
\096\000\097\000\112\000\098\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\038\000\039\000\040\000\041\000\
\122\000\123\000\042\000\043\000\044\000\135\000\136\000\059\000\
\060\000\061\000\062\000\063\000\064\000\065\000\048\000\030\000\
\045\000\024\000\025\000\137\000\026\000\138\000\139\000\144\000\
\159\000\147\000\027\000\230\000\160\000\161\000\059\000\060\000\
\061\000\062\000\063\000\064\000\065\000\171\000\028\000\029\000\
\172\000\209\000\162\000\187\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\038\000\039\000\040\000\041\000\
\190\000\194\000\042\000\043\000\044\000\188\000\195\000\189\000\
\048\000\253\000\196\000\024\000\025\000\199\000\026\000\203\000\
\045\000\208\000\027\000\002\001\027\000\223\000\221\000\231\000\
\234\000\235\000\225\000\004\001\251\000\252\000\100\000\241\000\
\028\000\029\000\045\000\248\000\088\000\077\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\038\000\039\000\
\040\000\041\000\043\000\102\000\042\000\043\000\044\000\046\000\
\103\000\104\000\105\000\106\000\107\000\108\000\102\000\109\000\
\121\000\120\000\045\000\110\000\111\000\112\000\113\000\093\000\
\092\000\079\000\109\000\119\000\225\000\028\000\044\000\118\000\
\102\000\043\000\115\000\044\000\114\000\115\000\116\000\117\000\
\118\000\119\000\120\000\113\000\083\000\240\000\102\000\232\000\
\115\000\116\000\117\000\118\000\119\000\120\000\038\000\074\000\
\038\000\038\000\109\000\038\000\038\000\075\000\003\001\222\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\224\000\135\000\000\000\038\000\038\000\038\000\038\000\131\000\
\129\000\131\000\117\000\118\000\119\000\120\000\000\000\000\000\
\029\000\000\000\000\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\000\000\038\000\038\000\038\000\
\083\000\090\000\000\000\084\000\106\000\038\000\038\000\038\000\
\107\000\000\000\037\000\090\000\037\000\037\000\038\000\037\000\
\037\000\135\000\000\000\000\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\106\000\081\000\000\000\037\000\
\037\000\037\000\037\000\103\000\081\000\081\000\082\000\000\000\
\000\000\000\000\103\000\020\000\000\000\082\000\082\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\112\000\037\000\037\000\037\000\110\000\110\000\000\000\000\000\
\000\000\037\000\037\000\037\000\110\000\030\000\000\000\030\000\
\030\000\000\000\037\000\030\000\000\000\000\000\000\000\030\000\
\030\000\030\000\030\000\030\000\030\000\030\000\000\000\112\000\
\112\000\000\000\030\000\030\000\030\000\030\000\000\000\112\000\
\000\000\000\000\000\000\000\000\000\000\000\000\021\000\000\000\
\000\000\000\000\030\000\030\000\030\000\030\000\030\000\030\000\
\030\000\000\000\030\000\000\000\030\000\030\000\030\000\000\000\
\000\000\000\000\000\000\000\000\030\000\030\000\030\000\000\000\
\027\000\000\000\027\000\027\000\000\000\030\000\027\000\000\000\
\000\000\000\000\027\000\027\000\027\000\027\000\027\000\027\000\
\027\000\000\000\000\000\000\000\000\000\027\000\027\000\027\000\
\027\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\022\000\000\000\000\000\000\000\027\000\027\000\027\000\
\027\000\027\000\027\000\027\000\000\000\027\000\000\000\027\000\
\027\000\027\000\000\000\000\000\000\000\000\000\000\000\027\000\
\027\000\027\000\000\000\028\000\000\000\028\000\028\000\000\000\
\027\000\028\000\000\000\000\000\000\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\000\000\000\000\000\000\000\000\
\028\000\028\000\028\000\028\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\041\000\000\000\000\000\000\000\
\028\000\028\000\028\000\028\000\028\000\028\000\028\000\000\000\
\028\000\000\000\028\000\028\000\028\000\000\000\000\000\000\000\
\000\000\000\000\028\000\028\000\028\000\000\000\029\000\000\000\
\029\000\029\000\000\000\028\000\029\000\000\000\000\000\000\000\
\029\000\029\000\029\000\029\000\029\000\029\000\029\000\000\000\
\000\000\000\000\000\000\029\000\029\000\029\000\029\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\040\000\
\000\000\000\000\000\000\029\000\029\000\029\000\029\000\029\000\
\029\000\029\000\000\000\029\000\000\000\029\000\029\000\029\000\
\000\000\000\000\000\000\000\000\000\000\029\000\029\000\029\000\
\000\000\020\000\000\000\020\000\020\000\000\000\029\000\020\000\
\000\000\000\000\000\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\000\000\000\000\000\000\000\000\020\000\020\000\
\020\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\019\000\000\000\000\000\000\000\020\000\020\000\
\020\000\020\000\020\000\020\000\020\000\000\000\020\000\000\000\
\020\000\020\000\020\000\000\000\000\000\000\000\000\000\000\000\
\020\000\020\000\020\000\000\000\021\000\000\000\021\000\021\000\
\000\000\020\000\021\000\000\000\000\000\000\000\021\000\021\000\
\021\000\021\000\021\000\021\000\021\000\000\000\000\000\000\000\
\000\000\021\000\021\000\021\000\021\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\018\000\000\000\000\000\
\000\000\021\000\021\000\021\000\021\000\021\000\021\000\021\000\
\000\000\021\000\000\000\021\000\021\000\021\000\000\000\000\000\
\000\000\000\000\000\000\021\000\021\000\021\000\000\000\022\000\
\000\000\022\000\022\000\000\000\021\000\022\000\000\000\000\000\
\000\000\022\000\022\000\022\000\022\000\022\000\022\000\022\000\
\000\000\000\000\000\000\000\000\022\000\022\000\022\000\022\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\008\000\000\000\000\000\000\000\022\000\022\000\022\000\022\000\
\022\000\022\000\022\000\000\000\022\000\000\000\022\000\022\000\
\022\000\000\000\000\000\000\000\000\000\000\000\022\000\022\000\
\022\000\000\000\041\000\000\000\041\000\041\000\005\000\022\000\
\041\000\000\000\000\000\000\000\041\000\041\000\041\000\041\000\
\041\000\041\000\041\000\000\000\000\000\000\000\000\000\041\000\
\041\000\041\000\041\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\004\000\000\000\000\000\041\000\
\041\000\041\000\041\000\041\000\041\000\041\000\000\000\041\000\
\000\000\041\000\041\000\041\000\000\000\000\000\000\000\000\000\
\000\000\041\000\041\000\041\000\000\000\040\000\000\000\040\000\
\040\000\000\000\041\000\040\000\000\000\000\000\000\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\000\000\000\000\
\000\000\000\000\040\000\040\000\040\000\040\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\031\000\
\000\000\000\000\040\000\040\000\040\000\040\000\040\000\040\000\
\040\000\000\000\040\000\000\000\040\000\040\000\040\000\000\000\
\000\000\000\000\000\000\000\000\040\000\040\000\040\000\000\000\
\019\000\000\000\019\000\019\000\038\000\040\000\019\000\000\000\
\000\000\000\000\019\000\019\000\019\000\019\000\019\000\019\000\
\019\000\000\000\000\000\000\000\000\000\019\000\019\000\019\000\
\019\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\009\000\000\000\000\000\019\000\019\000\019\000\
\019\000\000\000\000\000\000\000\000\000\019\000\000\000\019\000\
\019\000\019\000\000\000\000\000\000\000\000\000\000\000\019\000\
\019\000\019\000\000\000\018\000\000\000\018\000\018\000\000\000\
\019\000\018\000\000\000\000\000\000\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\000\000\000\000\000\000\000\000\
\018\000\018\000\018\000\018\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\003\000\000\000\000\000\
\018\000\018\000\018\000\018\000\000\000\000\000\000\000\000\000\
\018\000\000\000\018\000\018\000\018\000\000\000\000\000\000\000\
\000\000\000\000\018\000\018\000\018\000\000\000\008\000\042\000\
\008\000\008\000\000\000\018\000\008\000\000\000\000\000\000\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\000\000\
\000\000\000\000\000\000\008\000\008\000\008\000\008\000\000\000\
\000\000\000\000\000\000\000\000\005\000\000\000\005\000\005\000\
\000\000\000\000\005\000\008\000\008\000\000\000\000\000\000\000\
\000\000\000\000\000\000\008\000\005\000\008\000\008\000\008\000\
\000\000\005\000\005\000\005\000\005\000\008\000\008\000\008\000\
\000\000\000\000\004\000\002\000\004\000\004\000\008\000\000\000\
\004\000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\005\000\004\000\005\000\005\000\005\000\000\000\004\000\
\004\000\004\000\004\000\005\000\005\000\005\000\000\000\001\000\
\000\000\000\000\000\000\000\000\005\000\000\000\000\000\004\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\
\000\000\004\000\004\000\004\000\000\000\000\000\000\000\000\000\
\000\000\004\000\004\000\004\000\000\000\031\000\000\000\031\000\
\031\000\000\000\004\000\031\000\000\000\010\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\031\000\000\000\000\000\
\000\000\000\000\031\000\031\000\031\000\031\000\000\000\000\000\
\000\000\000\000\000\000\011\000\000\000\000\000\000\000\038\000\
\000\000\000\000\031\000\000\000\038\000\038\000\038\000\038\000\
\038\000\038\000\031\000\038\000\031\000\031\000\031\000\038\000\
\038\000\038\000\038\000\000\000\031\000\031\000\031\000\000\000\
\009\000\000\000\009\000\009\000\000\000\031\000\009\000\000\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\000\000\
\009\000\038\000\000\000\000\000\000\000\009\000\009\000\009\000\
\009\000\000\000\000\000\038\000\000\000\156\000\000\000\000\000\
\000\000\000\000\102\000\000\000\000\000\009\000\000\000\103\000\
\104\000\105\000\106\000\107\000\108\000\009\000\109\000\009\000\
\009\000\009\000\110\000\111\000\112\000\113\000\000\000\009\000\
\009\000\009\000\000\000\003\000\000\000\003\000\003\000\000\000\
\009\000\003\000\000\000\114\000\115\000\116\000\117\000\118\000\
\119\000\120\000\000\000\003\000\000\000\000\000\000\000\000\000\
\003\000\003\000\000\000\003\000\000\000\042\000\000\000\042\000\
\042\000\000\000\000\000\042\000\000\000\000\000\000\000\000\000\
\003\000\000\000\000\000\000\000\000\000\042\000\000\000\000\000\
\003\000\000\000\003\000\003\000\003\000\000\000\000\000\000\000\
\000\000\000\000\003\000\003\000\003\000\000\000\000\000\102\000\
\000\000\000\000\042\000\003\000\103\000\104\000\105\000\106\000\
\107\000\108\000\042\000\109\000\042\000\042\000\042\000\110\000\
\111\000\112\000\113\000\000\000\042\000\042\000\042\000\000\000\
\000\000\002\000\000\000\002\000\002\000\042\000\000\000\002\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000\000\000\
\000\000\002\000\000\000\201\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\001\000\000\000\001\000\
\001\000\000\000\000\000\001\000\000\000\000\000\002\000\000\000\
\000\000\000\000\000\000\000\000\000\000\001\000\002\000\000\000\
\002\000\002\000\002\000\000\000\000\000\000\000\000\000\000\000\
\002\000\002\000\002\000\000\000\000\000\000\000\000\000\000\000\
\000\000\002\000\001\000\010\000\000\000\010\000\010\000\000\000\
\000\000\010\000\001\000\000\000\001\000\001\000\001\000\046\000\
\000\000\049\000\050\000\010\000\001\000\001\000\001\000\000\000\
\000\000\011\000\000\000\011\000\011\000\001\000\000\000\011\000\
\000\000\000\000\000\000\000\000\000\000\082\000\084\000\085\000\
\010\000\011\000\090\000\000\000\000\000\000\000\000\000\000\000\
\010\000\000\000\010\000\010\000\010\000\000\000\099\000\100\000\
\101\000\000\000\010\000\010\000\010\000\000\000\011\000\000\000\
\000\000\000\000\000\000\010\000\000\000\000\000\011\000\000\000\
\011\000\011\000\011\000\000\000\000\000\000\000\000\000\000\000\
\011\000\011\000\011\000\000\000\000\000\000\000\000\000\000\000\
\150\000\011\000\000\000\151\000\154\000\155\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\163\000\
\164\000\165\000\166\000\167\000\168\000\169\000\170\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\173\000\174\000\175\000\176\000\177\000\178\000\
\179\000\180\000\181\000\182\000\183\000\185\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\048\000\000\000\193\000\024\000\
\025\000\000\000\026\000\000\000\197\000\000\000\000\000\198\000\
\027\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\204\000\205\000\206\000\207\000\028\000\029\000\210\000\000\000\
\000\000\000\000\030\000\031\000\032\000\033\000\034\000\035\000\
\036\000\037\000\038\000\039\000\040\000\041\000\000\000\000\000\
\042\000\043\000\044\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\003\000\045\000\226\000\
\229\000\004\000\005\000\051\000\000\000\006\000\151\000\000\000\
\007\000\000\000\000\000\008\000\009\000\010\000\000\000\000\000\
\011\000\012\000\000\000\000\000\236\000\237\000\000\000\238\000\
\000\000\239\000\000\000\000\000\000\000\226\000\000\000\000\000\
\048\000\000\000\000\000\024\000\025\000\247\000\026\000\000\000\
\000\000\000\000\000\000\000\000\027\000\000\000\000\000\254\000\
\000\000\000\000\000\000\000\000\000\000\000\000\001\001\000\000\
\028\000\029\000\000\000\226\000\000\000\000\000\030\000\031\000\
\032\000\033\000\034\000\035\000\036\000\037\000\038\000\039\000\
\040\000\041\000\000\000\000\000\042\000\043\000\044\000\048\000\
\000\000\000\000\024\000\025\000\000\000\026\000\000\000\000\000\
\000\000\000\000\045\000\027\000\000\000\000\000\000\000\145\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\000\
\029\000\000\000\000\000\000\000\000\000\030\000\031\000\032\000\
\033\000\034\000\035\000\036\000\037\000\038\000\039\000\040\000\
\041\000\000\000\000\000\042\000\043\000\044\000\000\000\023\000\
\000\000\228\000\024\000\025\000\000\000\026\000\000\000\000\000\
\000\000\045\000\000\000\027\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\028\000\
\029\000\000\000\000\000\000\000\000\000\030\000\031\000\032\000\
\033\000\034\000\035\000\036\000\037\000\038\000\039\000\040\000\
\041\000\000\000\000\000\042\000\043\000\044\000\048\000\000\000\
\000\000\024\000\025\000\000\000\026\000\000\000\000\000\000\000\
\000\000\045\000\027\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\028\000\029\000\
\000\000\000\000\000\000\000\000\030\000\031\000\032\000\033\000\
\034\000\035\000\036\000\037\000\038\000\039\000\040\000\041\000\
\000\000\000\000\042\000\043\000\044\000\048\000\000\000\000\000\
\024\000\025\000\000\000\026\000\000\000\000\000\000\000\000\000\
\045\000\027\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\028\000\029\000\000\000\
\000\000\000\000\000\000\030\000\031\000\032\000\033\000\034\000\
\035\000\036\000\037\000\038\000\039\000\040\000\041\000\211\000\
\000\000\000\000\000\000\000\000\102\000\000\000\000\000\000\000\
\000\000\103\000\104\000\105\000\106\000\107\000\108\000\045\000\
\109\000\000\000\000\000\000\000\110\000\111\000\112\000\113\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\114\000\115\000\116\000\
\117\000\118\000\119\000\120\000\213\000\000\000\000\000\000\000\
\000\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\000\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\214\000\000\000\000\000\000\000\000\000\102\000\000\000\
\000\000\000\000\000\000\103\000\104\000\105\000\106\000\107\000\
\108\000\000\000\109\000\000\000\000\000\000\000\110\000\111\000\
\112\000\113\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\114\000\
\115\000\116\000\117\000\118\000\119\000\120\000\215\000\000\000\
\000\000\000\000\000\000\102\000\000\000\000\000\000\000\000\000\
\103\000\104\000\105\000\106\000\107\000\108\000\000\000\109\000\
\000\000\000\000\000\000\110\000\111\000\112\000\113\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\114\000\115\000\116\000\117\000\
\118\000\119\000\120\000\218\000\000\000\000\000\000\000\000\000\
\102\000\000\000\000\000\000\000\000\000\103\000\104\000\105\000\
\106\000\107\000\108\000\000\000\109\000\000\000\000\000\000\000\
\110\000\111\000\112\000\113\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\114\000\115\000\116\000\117\000\118\000\119\000\120\000\
\249\000\000\000\000\000\000\000\000\000\102\000\000\000\000\000\
\000\000\000\000\103\000\104\000\105\000\106\000\107\000\108\000\
\000\000\109\000\000\000\000\000\000\000\110\000\111\000\112\000\
\113\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\114\000\115\000\
\116\000\117\000\118\000\119\000\120\000\006\001\000\000\000\000\
\000\000\000\000\102\000\000\000\000\000\000\000\000\000\103\000\
\104\000\105\000\106\000\107\000\108\000\000\000\109\000\000\000\
\000\000\000\000\110\000\111\000\112\000\113\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\114\000\115\000\116\000\117\000\118\000\
\119\000\120\000\233\000\000\000\000\000\102\000\000\000\000\000\
\000\000\000\000\103\000\104\000\105\000\106\000\107\000\108\000\
\000\000\109\000\000\000\000\000\000\000\110\000\111\000\112\000\
\113\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\114\000\115\000\
\116\000\117\000\118\000\119\000\120\000\219\000\000\000\102\000\
\000\000\000\000\000\000\000\000\103\000\104\000\105\000\106\000\
\107\000\108\000\000\000\109\000\000\000\000\000\000\000\110\000\
\111\000\112\000\113\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000\102\000\
\000\000\000\000\000\000\000\000\103\000\104\000\105\000\106\000\
\107\000\108\000\000\000\109\000\000\000\000\000\000\000\110\000\
\111\000\112\000\113\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000\220\000\
\102\000\000\000\000\000\000\000\000\000\103\000\104\000\105\000\
\106\000\107\000\108\000\000\000\109\000\000\000\000\000\000\000\
\110\000\111\000\112\000\113\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\114\000\115\000\116\000\117\000\118\000\119\000\120\000\
\246\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\000\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\158\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\202\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\212\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\216\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\217\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\250\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\000\000\109\000\000\000\000\000\
\000\000\110\000\111\000\112\000\113\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\102\000\000\000\000\000\000\000\000\000\103\000\104\000\
\105\000\106\000\107\000\108\000\000\000\109\000\000\000\102\000\
\000\000\000\000\000\000\112\000\103\000\104\000\105\000\106\000\
\107\000\108\000\000\000\109\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\000\115\000\116\000\117\000\118\000\119\000\
\120\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\114\000\115\000\116\000\117\000\118\000\119\000\120\000"

let yycheck = "\072\000\
\000\000\006\001\000\000\000\000\000\000\000\000\074\000\000\000\
\022\001\000\000\000\000\000\000\028\000\029\000\225\000\006\001\
\005\001\014\001\006\001\014\001\009\001\010\001\065\001\001\001\
\005\001\001\001\069\001\001\001\006\001\010\001\006\001\000\000\
\006\001\008\000\022\001\001\000\011\000\000\000\001\001\001\001\
\000\000\003\001\047\001\001\001\255\000\011\001\078\001\079\001\
\001\001\122\000\001\001\062\001\014\001\015\001\063\001\053\001\
\070\001\023\001\000\000\005\001\000\000\005\001\001\001\000\000\
\003\001\004\001\005\001\058\001\007\001\047\001\058\001\047\001\
\005\001\047\001\013\001\014\001\015\001\074\001\005\001\074\001\
\077\001\078\001\077\001\078\001\050\001\005\001\025\001\026\001\
\005\001\005\001\000\000\005\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\022\001\047\001\045\001\046\001\047\001\047\001\001\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\001\001\000\000\
\059\001\004\001\005\001\005\001\007\001\009\001\001\001\024\001\
\058\001\061\001\013\001\199\000\001\001\022\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\001\001\025\001\026\001\
\001\001\161\000\058\001\047\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\005\001\022\001\045\001\046\001\047\001\078\001\024\001\078\001\
\001\001\242\000\050\001\004\001\005\001\054\001\007\001\006\001\
\059\001\050\001\000\000\252\000\013\001\006\001\012\001\001\001\
\051\001\001\001\069\001\070\001\051\001\065\001\000\000\006\001\
\025\001\026\001\001\001\006\001\000\000\006\001\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\012\001\011\001\045\001\046\001\047\001\001\001\
\016\001\017\001\018\001\019\001\020\001\021\001\011\001\023\001\
\006\001\000\000\059\001\027\001\028\001\029\001\030\001\000\000\
\000\000\006\001\023\001\000\000\069\001\000\000\012\001\000\000\
\000\000\051\001\000\000\051\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\000\000\025\000\221\000\011\001\202\000\
\045\001\046\001\047\001\048\001\049\001\050\001\006\001\017\000\
\008\001\009\001\023\001\011\001\012\001\017\000\070\001\190\000\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\194\000\022\001\255\255\027\001\028\001\029\001\030\001\022\001\
\022\001\024\001\047\001\048\001\049\001\050\001\255\255\255\255\
\000\000\255\255\255\255\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\255\255\053\001\054\001\055\001\
\054\001\053\001\255\255\054\001\053\001\061\001\062\001\063\001\
\053\001\255\255\006\001\063\001\008\001\009\001\070\001\011\001\
\012\001\070\001\255\255\255\255\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\053\001\054\001\255\255\027\001\
\028\001\029\001\030\001\054\001\061\001\062\001\054\001\255\255\
\255\255\255\255\061\001\000\000\255\255\061\001\062\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\022\001\053\001\054\001\055\001\053\001\054\001\255\255\255\255\
\255\255\061\001\062\001\063\001\061\001\006\001\255\255\008\001\
\009\001\255\255\070\001\012\001\255\255\255\255\255\255\016\001\
\017\001\018\001\019\001\020\001\021\001\022\001\255\255\053\001\
\054\001\255\255\027\001\028\001\029\001\030\001\255\255\061\001\
\255\255\255\255\255\255\255\255\255\255\255\255\000\000\255\255\
\255\255\255\255\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\255\255\051\001\255\255\053\001\054\001\055\001\255\255\
\255\255\255\255\255\255\255\255\061\001\062\001\063\001\255\255\
\006\001\255\255\008\001\009\001\255\255\070\001\012\001\255\255\
\255\255\255\255\016\001\017\001\018\001\019\001\020\001\021\001\
\022\001\255\255\255\255\255\255\255\255\027\001\028\001\029\001\
\030\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\000\000\255\255\255\255\255\255\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\255\255\051\001\255\255\053\001\
\054\001\055\001\255\255\255\255\255\255\255\255\255\255\061\001\
\062\001\063\001\255\255\006\001\255\255\008\001\009\001\255\255\
\070\001\012\001\255\255\255\255\255\255\016\001\017\001\018\001\
\019\001\020\001\021\001\022\001\255\255\255\255\255\255\255\255\
\027\001\028\001\029\001\030\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\255\255\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\255\255\
\051\001\255\255\053\001\054\001\055\001\255\255\255\255\255\255\
\255\255\255\255\061\001\062\001\063\001\255\255\006\001\255\255\
\008\001\009\001\255\255\070\001\012\001\255\255\255\255\255\255\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\255\255\
\255\255\255\255\255\255\027\001\028\001\029\001\030\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\000\000\
\255\255\255\255\255\255\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\255\255\051\001\255\255\053\001\054\001\055\001\
\255\255\255\255\255\255\255\255\255\255\061\001\062\001\063\001\
\255\255\006\001\255\255\008\001\009\001\255\255\070\001\012\001\
\255\255\255\255\255\255\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\255\255\255\255\255\255\255\255\027\001\028\001\
\029\001\030\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\255\255\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\255\255\051\001\255\255\
\053\001\054\001\055\001\255\255\255\255\255\255\255\255\255\255\
\061\001\062\001\063\001\255\255\006\001\255\255\008\001\009\001\
\255\255\070\001\012\001\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\255\255\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\000\000\255\255\255\255\
\255\255\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\255\255\051\001\255\255\053\001\054\001\055\001\255\255\255\255\
\255\255\255\255\255\255\061\001\062\001\063\001\255\255\006\001\
\255\255\008\001\009\001\255\255\070\001\012\001\255\255\255\255\
\255\255\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\255\255\255\255\255\255\255\255\027\001\028\001\029\001\030\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\000\000\255\255\255\255\255\255\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\255\255\051\001\255\255\053\001\054\001\
\055\001\255\255\255\255\255\255\255\255\255\255\061\001\062\001\
\063\001\255\255\006\001\255\255\008\001\009\001\000\000\070\001\
\012\001\255\255\255\255\255\255\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\255\255\255\255\255\255\255\255\027\001\
\028\001\029\001\030\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\000\000\255\255\255\255\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\255\255\051\001\
\255\255\053\001\054\001\055\001\255\255\255\255\255\255\255\255\
\255\255\061\001\062\001\063\001\255\255\006\001\255\255\008\001\
\009\001\255\255\070\001\012\001\255\255\255\255\255\255\016\001\
\017\001\018\001\019\001\020\001\021\001\022\001\255\255\255\255\
\255\255\255\255\027\001\028\001\029\001\030\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\000\000\
\255\255\255\255\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\255\255\051\001\255\255\053\001\054\001\055\001\255\255\
\255\255\255\255\255\255\255\255\061\001\062\001\063\001\255\255\
\006\001\255\255\008\001\009\001\000\000\070\001\012\001\255\255\
\255\255\255\255\016\001\017\001\018\001\019\001\020\001\021\001\
\022\001\255\255\255\255\255\255\255\255\027\001\028\001\029\001\
\030\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\000\000\255\255\255\255\043\001\044\001\045\001\
\046\001\255\255\255\255\255\255\255\255\051\001\255\255\053\001\
\054\001\055\001\255\255\255\255\255\255\255\255\255\255\061\001\
\062\001\063\001\255\255\006\001\255\255\008\001\009\001\255\255\
\070\001\012\001\255\255\255\255\255\255\016\001\017\001\018\001\
\019\001\020\001\021\001\022\001\255\255\255\255\255\255\255\255\
\027\001\028\001\029\001\030\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\000\000\255\255\255\255\
\043\001\044\001\045\001\046\001\255\255\255\255\255\255\255\255\
\051\001\255\255\053\001\054\001\055\001\255\255\255\255\255\255\
\255\255\255\255\061\001\062\001\063\001\255\255\006\001\000\000\
\008\001\009\001\255\255\070\001\012\001\255\255\255\255\255\255\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\255\255\
\255\255\255\255\255\255\027\001\028\001\029\001\030\001\255\255\
\255\255\255\255\255\255\255\255\006\001\255\255\008\001\009\001\
\255\255\255\255\012\001\043\001\044\001\255\255\255\255\255\255\
\255\255\255\255\255\255\051\001\022\001\053\001\054\001\055\001\
\255\255\027\001\028\001\029\001\030\001\061\001\062\001\063\001\
\255\255\255\255\006\001\000\000\008\001\009\001\070\001\255\255\
\012\001\043\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\051\001\022\001\053\001\054\001\055\001\255\255\027\001\
\028\001\029\001\030\001\061\001\062\001\063\001\255\255\000\000\
\255\255\255\255\255\255\255\255\070\001\255\255\255\255\043\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\051\001\
\255\255\053\001\054\001\055\001\255\255\255\255\255\255\255\255\
\255\255\061\001\062\001\063\001\255\255\006\001\255\255\008\001\
\009\001\255\255\070\001\012\001\255\255\000\000\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\022\001\255\255\255\255\
\255\255\255\255\027\001\028\001\029\001\030\001\255\255\255\255\
\255\255\255\255\255\255\000\000\255\255\255\255\255\255\011\001\
\255\255\255\255\043\001\255\255\016\001\017\001\018\001\019\001\
\020\001\021\001\051\001\023\001\053\001\054\001\055\001\027\001\
\028\001\029\001\030\001\255\255\061\001\062\001\063\001\255\255\
\006\001\255\255\008\001\009\001\255\255\070\001\012\001\255\255\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\255\255\
\022\001\053\001\255\255\255\255\255\255\027\001\028\001\029\001\
\030\001\255\255\255\255\063\001\255\255\006\001\255\255\255\255\
\255\255\255\255\011\001\255\255\255\255\043\001\255\255\016\001\
\017\001\018\001\019\001\020\001\021\001\051\001\023\001\053\001\
\054\001\055\001\027\001\028\001\029\001\030\001\255\255\061\001\
\062\001\063\001\255\255\006\001\255\255\008\001\009\001\255\255\
\070\001\012\001\255\255\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\255\255\022\001\255\255\255\255\255\255\255\255\
\027\001\028\001\255\255\030\001\255\255\006\001\255\255\008\001\
\009\001\255\255\255\255\012\001\255\255\255\255\255\255\255\255\
\043\001\255\255\255\255\255\255\255\255\022\001\255\255\255\255\
\051\001\255\255\053\001\054\001\055\001\255\255\255\255\255\255\
\255\255\255\255\061\001\062\001\063\001\255\255\255\255\011\001\
\255\255\255\255\043\001\070\001\016\001\017\001\018\001\019\001\
\020\001\021\001\051\001\023\001\053\001\054\001\055\001\027\001\
\028\001\029\001\030\001\255\255\061\001\062\001\063\001\255\255\
\255\255\006\001\255\255\008\001\009\001\070\001\255\255\012\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\255\255\
\255\255\022\001\255\255\055\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\006\001\255\255\008\001\
\009\001\255\255\255\255\012\001\255\255\255\255\043\001\255\255\
\255\255\255\255\255\255\255\255\255\255\022\001\051\001\255\255\
\053\001\054\001\055\001\255\255\255\255\255\255\255\255\255\255\
\061\001\062\001\063\001\255\255\255\255\255\255\255\255\255\255\
\255\255\070\001\043\001\006\001\255\255\008\001\009\001\255\255\
\255\255\012\001\051\001\255\255\053\001\054\001\055\001\003\000\
\255\255\005\000\006\000\022\001\061\001\062\001\063\001\255\255\
\255\255\006\001\255\255\008\001\009\001\070\001\255\255\012\001\
\255\255\255\255\255\255\255\255\255\255\025\000\026\000\027\000\
\043\001\022\001\030\000\255\255\255\255\255\255\255\255\255\255\
\051\001\255\255\053\001\054\001\055\001\255\255\042\000\043\000\
\044\000\255\255\061\001\062\001\063\001\255\255\043\001\255\255\
\255\255\255\255\255\255\070\001\255\255\255\255\051\001\255\255\
\053\001\054\001\055\001\255\255\255\255\255\255\255\255\255\255\
\061\001\062\001\063\001\255\255\255\255\255\255\255\255\255\255\
\076\000\070\001\255\255\079\000\080\000\081\000\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\091\000\
\092\000\093\000\094\000\095\000\096\000\097\000\098\000\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\110\000\111\000\112\000\113\000\114\000\115\000\
\116\000\117\000\118\000\119\000\120\000\121\000\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\001\001\255\255\138\000\004\001\
\005\001\255\255\007\001\255\255\144\000\255\255\255\255\147\000\
\013\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\156\000\157\000\158\000\159\000\025\001\026\001\162\000\255\255\
\255\255\255\255\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\255\255\255\255\
\045\001\046\001\047\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\052\001\059\001\195\000\
\196\000\056\001\057\001\064\001\255\255\060\001\202\000\255\255\
\063\001\255\255\255\255\066\001\067\001\068\001\255\255\255\255\
\071\001\072\001\255\255\255\255\216\000\217\000\255\255\219\000\
\255\255\221\000\255\255\255\255\255\255\225\000\255\255\255\255\
\001\001\255\255\255\255\004\001\005\001\233\000\007\001\255\255\
\255\255\255\255\255\255\255\255\013\001\255\255\255\255\243\000\
\255\255\255\255\255\255\255\255\255\255\255\255\250\000\255\255\
\025\001\026\001\255\255\255\000\255\255\255\255\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\255\255\255\255\045\001\046\001\047\001\001\001\
\255\255\255\255\004\001\005\001\255\255\007\001\255\255\255\255\
\255\255\255\255\059\001\013\001\255\255\255\255\255\255\064\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\025\001\
\026\001\255\255\255\255\255\255\255\255\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\255\255\255\255\045\001\046\001\047\001\255\255\001\001\
\255\255\051\001\004\001\005\001\255\255\007\001\255\255\255\255\
\255\255\059\001\255\255\013\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\025\001\
\026\001\255\255\255\255\255\255\255\255\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\255\255\255\255\045\001\046\001\047\001\001\001\255\255\
\255\255\004\001\005\001\255\255\007\001\255\255\255\255\255\255\
\255\255\059\001\013\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\025\001\026\001\
\255\255\255\255\255\255\255\255\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\255\255\255\255\045\001\046\001\047\001\001\001\255\255\255\255\
\004\001\005\001\255\255\007\001\255\255\255\255\255\255\255\255\
\059\001\013\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\025\001\026\001\255\255\
\255\255\255\255\255\255\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\006\001\
\255\255\255\255\255\255\255\255\011\001\255\255\255\255\255\255\
\255\255\016\001\017\001\018\001\019\001\020\001\021\001\059\001\
\023\001\255\255\255\255\255\255\027\001\028\001\029\001\030\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\006\001\255\255\255\255\255\255\
\255\255\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\006\001\255\255\255\255\255\255\255\255\011\001\255\255\
\255\255\255\255\255\255\016\001\017\001\018\001\019\001\020\001\
\021\001\255\255\023\001\255\255\255\255\255\255\027\001\028\001\
\029\001\030\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\006\001\255\255\
\255\255\255\255\255\255\011\001\255\255\255\255\255\255\255\255\
\016\001\017\001\018\001\019\001\020\001\021\001\255\255\023\001\
\255\255\255\255\255\255\027\001\028\001\029\001\030\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\006\001\255\255\255\255\255\255\255\255\
\011\001\255\255\255\255\255\255\255\255\016\001\017\001\018\001\
\019\001\020\001\021\001\255\255\023\001\255\255\255\255\255\255\
\027\001\028\001\029\001\030\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\006\001\255\255\255\255\255\255\255\255\011\001\255\255\255\255\
\255\255\255\255\016\001\017\001\018\001\019\001\020\001\021\001\
\255\255\023\001\255\255\255\255\255\255\027\001\028\001\029\001\
\030\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\006\001\255\255\255\255\
\255\255\255\255\011\001\255\255\255\255\255\255\255\255\016\001\
\017\001\018\001\019\001\020\001\021\001\255\255\023\001\255\255\
\255\255\255\255\027\001\028\001\029\001\030\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\008\001\255\255\255\255\011\001\255\255\255\255\
\255\255\255\255\016\001\017\001\018\001\019\001\020\001\021\001\
\255\255\023\001\255\255\255\255\255\255\027\001\028\001\029\001\
\030\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\009\001\255\255\011\001\
\255\255\255\255\255\255\255\255\016\001\017\001\018\001\019\001\
\020\001\021\001\255\255\023\001\255\255\255\255\255\255\027\001\
\028\001\029\001\030\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\011\001\
\255\255\255\255\255\255\255\255\016\001\017\001\018\001\019\001\
\020\001\021\001\255\255\023\001\255\255\255\255\255\255\027\001\
\028\001\029\001\030\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\011\001\255\255\255\255\255\255\255\255\016\001\017\001\018\001\
\019\001\020\001\021\001\255\255\023\001\255\255\255\255\255\255\
\027\001\028\001\029\001\030\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\029\001\030\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\011\001\255\255\255\255\255\255\255\255\016\001\017\001\
\018\001\019\001\020\001\021\001\255\255\023\001\255\255\011\001\
\255\255\255\255\255\255\029\001\016\001\017\001\018\001\019\001\
\020\001\021\001\255\255\023\001\255\255\255\255\255\255\255\255\
\255\255\255\255\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001"

let yynames_const = "\
  LPAR\000\
  RPAR\000\
  IF\000\
  ELSE\000\
  COLON\000\
  COLONCOLON\000\
  DOT\000\
  DOTDOT\000\
  AMP\000\
  INT\000\
  FLOAT\000\
  LT\000\
  GT\000\
  LE\000\
  GE\000\
  EQ\000\
  NE\000\
  COMMA\000\
  ARROW\000\
  EQUAL\000\
  FORALL\000\
  EXISTS\000\
  IFF\000\
  IMPLIES\000\
  AND\000\
  OR\000\
  NOT\000\
  TRUE\000\
  FALSE\000\
  OLD\000\
  AT\000\
  RESULT\000\
  BLOCK_LENGTH\000\
  BASE_ADDR\000\
  VALID\000\
  VALID_INDEX\000\
  VALID_RANGE\000\
  FRESH\000\
  THEN\000\
  QUESTION\000\
  MINUS\000\
  PLUS\000\
  STAR\000\
  SLASH\000\
  PERCENT\000\
  LSQUARE\000\
  RSQUARE\000\
  EOF\000\
  INVARIANT\000\
  VARIANT\000\
  DECREASES\000\
  FOR\000\
  LABEL\000\
  ASSERT\000\
  SEMICOLON\000\
  NULL\000\
  REQUIRES\000\
  ENSURES\000\
  ASSIGNS\000\
  LOOP_ASSIGNS\000\
  NOTHING\000\
  READS\000\
  LOGIC\000\
  PREDICATE\000\
  AXIOM\000\
  LBRACE\000\
  RBRACE\000\
  GHOST\000\
  SET\000\
  VOID\000\
  CHAR\000\
  SIGNED\000\
  UNSIGNED\000\
  SHORT\000\
  LONG\000\
  DOUBLE\000\
  STRUCT\000\
  ENUM\000\
  UNION\000\
  "

let yynames_block = "\
  IDENTIFIER\000\
  STRING_LITERAL\000\
  TYPENAME\000\
  CONSTANT\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 76 "c/clparser.mly"
                      ( info (PLimplies (_1, _3)) )
# 1134 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 77 "c/clparser.mly"
                  ( info (PLiff (_1, _3)) )
# 1142 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 78 "c/clparser.mly"
                     ( info (PLor (_1, _3)) )
# 1150 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 79 "c/clparser.mly"
                     ( info (PLand (_1, _3)) )
# 1158 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 80 "c/clparser.mly"
                           ( info (PLnot _2) )
# 1165 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    Obj.repr(
# 81 "c/clparser.mly"
       ( info PLtrue )
# 1171 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    Obj.repr(
# 82 "c/clparser.mly"
        ( info PLfalse )
# 1177 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _2 = (peek_val parser_env 1 : 'relation) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 83 "c/clparser.mly"
                                           ( info (PLrel (_1, _2, _3)) )
# 1186 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 4 : 'lexpr) in
    let _4 = (peek_val parser_env 2 : 'lexpr) in
    let _6 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 85 "c/clparser.mly"
      ( info (PLif (_2, _4, _6)) )
# 1195 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'ne_parameters) in
    let _4 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 87 "c/clparser.mly"
      ( info (PLforall (_2, _4)) )
# 1203 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'ne_parameters) in
    let _4 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 89 "c/clparser.mly"
      ( info (PLexists (_2, _4)) )
# 1211 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 90 "c/clparser.mly"
                        ( info (PLvalid (_3)) )
# 1218 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 3 : 'lexpr) in
    let _5 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 91 "c/clparser.mly"
                                          ( info (PLvalid_index (_3,_5)) )
# 1226 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 5 : 'lexpr) in
    let _5 = (peek_val parser_env 3 : 'lexpr) in
    let _7 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 93 "c/clparser.mly"
      ( info (PLvalid_range (_3,_5,_7)) )
# 1235 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 94 "c/clparser.mly"
                        ( info (PLfresh (_3)) )
# 1242 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    Obj.repr(
# 96 "c/clparser.mly"
       ( info PLnull )
# 1248 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : Clogic.constant) in
    Obj.repr(
# 97 "c/clparser.mly"
           ( info (PLconstant _1) )
# 1255 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 98 "c/clparser.mly"
                   ( info (PLbinop (_1, Badd, _3)) )
# 1263 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 99 "c/clparser.mly"
                    ( info (PLbinop (_1, Bsub, _3)) )
# 1271 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 100 "c/clparser.mly"
                   ( info (PLbinop (_1, Bmul, _3)) )
# 1279 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 101 "c/clparser.mly"
                    ( info (PLbinop (_1, Bdiv, _3)) )
# 1287 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 102 "c/clparser.mly"
                      ( info (PLbinop (_1, Bmod, _3)) )
# 1295 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 103 "c/clparser.mly"
                         ( info (PLarrow (_1, _3)) )
# 1303 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 104 "c/clparser.mly"
                       ( info (PLdot (_1, _3)) )
# 1311 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'lexpr) in
    let _3 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 105 "c/clparser.mly"
                              ( info (PLarrget (_1, _3)) )
# 1319 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 5 : 'lexpr) in
    let _3 = (peek_val parser_env 3 : 'lexpr_option) in
    let _5 = (peek_val parser_env 1 : 'lexpr_option) in
    Obj.repr(
# 107 "c/clparser.mly"
   ( info (PLrange (_1, _3, _5)) )
# 1328 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 108 "c/clparser.mly"
                                ( info (PLunop (Uminus, _2)) )
# 1335 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 109 "c/clparser.mly"
                               ( _2 )
# 1342 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 110 "c/clparser.mly"
             ( info (PLunop (Ustar, _2)) )
# 1349 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 111 "c/clparser.mly"
            ( info (PLunop (Uamp, _2)) )
# 1356 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'lexpr) in
    let _3 = (peek_val parser_env 2 : 'lexpr) in
    let _5 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 113 "c/clparser.mly"
    ( info (PLif (_1, _3, _5)) )
# 1365 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 114 "c/clparser.mly"
                      ( info (PLold _3) )
# 1372 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 3 : 'lexpr) in
    let _5 = (peek_val parser_env 1 : string) in
    Obj.repr(
# 115 "c/clparser.mly"
                                      ( info (PLat (_3, _5)) )
# 1380 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 116 "c/clparser.mly"
                            ( info (PLbase_addr _3) )
# 1387 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 117 "c/clparser.mly"
                               ( info (PLblock_length _3) )
# 1394 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    Obj.repr(
# 118 "c/clparser.mly"
         ( info PLresult )
# 1400 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 120 "c/clparser.mly"
                                 ( _2 )
# 1407 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 121 "c/clparser.mly"
             ( info (PLvar (Info.default_var_info _1)) )
# 1414 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : string) in
    let _3 = (peek_val parser_env 1 : 'lexpr_list) in
    Obj.repr(
# 123 "c/clparser.mly"
    ( info (PLapp (Info.default_logic_info _1, _3)) )
# 1422 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'logic_type_not_id) in
    let _4 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 125 "c/clparser.mly"
                                                    ( info (PLcast (_2, _4)) )
# 1430 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'lexpr) in
    let _4 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 127 "c/clparser.mly"
    ( match _2.lexpr_node with
	| PLvar x -> info (PLcast (LTvar x.Info.var_name, _4))
	| _ -> raise Parse_error )
# 1440 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 130 "c/clparser.mly"
                                               ( info (PLnamed (_1, _3)) )
# 1448 "c/clparser.ml"
               : 'lexpr))
; (fun parser_env ->
    Obj.repr(
# 134 "c/clparser.mly"
                ( None )
# 1454 "c/clparser.ml"
               : 'lexpr_option))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 135 "c/clparser.mly"
                ( Some _1 )
# 1461 "c/clparser.ml"
               : 'lexpr_option))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 139 "c/clparser.mly"
             ( LTvar _1 )
# 1468 "c/clparser.ml"
               : 'logic_type))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : string) in
    let _2 = (peek_val parser_env 0 : 'stars) in
    Obj.repr(
# 140 "c/clparser.mly"
                   ( _2 (LTvar _1) )
# 1476 "c/clparser.ml"
               : 'logic_type))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'logic_type_not_id) in
    Obj.repr(
# 141 "c/clparser.mly"
                    ( _1 )
# 1483 "c/clparser.ml"
               : 'logic_type))
; (fun parser_env ->
    Obj.repr(
# 145 "c/clparser.mly"
                 ( LTvoid )
# 1489 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 146 "c/clparser.mly"
                 ( LTint )
# 1495 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 147 "c/clparser.mly"
                 ( LTint )
# 1501 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 148 "c/clparser.mly"
                 ( LTint )
# 1507 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 149 "c/clparser.mly"
                 ( LTint )
# 1513 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 150 "c/clparser.mly"
                 ( LTint )
# 1519 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 151 "c/clparser.mly"
                 ( LTint )
# 1525 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 152 "c/clparser.mly"
                 ( LTint )
# 1531 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 153 "c/clparser.mly"
                 ( LTint )
# 1537 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 154 "c/clparser.mly"
                 ( LTint )
# 1543 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 155 "c/clparser.mly"
                 ( LTint )
# 1549 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 156 "c/clparser.mly"
                 ( LTint )
# 1555 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 157 "c/clparser.mly"
                 ( LTint )
# 1561 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 158 "c/clparser.mly"
                   ( LTint )
# 1567 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 160 "c/clparser.mly"
              ( LTint )
# 1573 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 162 "c/clparser.mly"
                     ( LTint )
# 1579 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 164 "c/clparser.mly"
              ( LTfloat )
# 1585 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 165 "c/clparser.mly"
              ( LTfloat )
# 1591 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 166 "c/clparser.mly"
              ( LTfloat )
# 1597 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 172 "c/clparser.mly"
                   ( LTvar _1 )
# 1604 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'logic_type_not_id) in
    Obj.repr(
# 173 "c/clparser.mly"
                         ( LTpointer _1 )
# 1611 "c/clparser.ml"
               : 'logic_type_not_id))
; (fun parser_env ->
    Obj.repr(
# 177 "c/clparser.mly"
       ( fun t -> LTpointer t )
# 1617 "c/clparser.ml"
               : 'stars))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'stars) in
    Obj.repr(
# 178 "c/clparser.mly"
             ( fun t -> _1 (LTpointer t) )
# 1624 "c/clparser.ml"
               : 'stars))
; (fun parser_env ->
    Obj.repr(
# 182 "c/clparser.mly"
          ( Lt )
# 1630 "c/clparser.ml"
               : 'relation))
; (fun parser_env ->
    Obj.repr(
# 183 "c/clparser.mly"
          ( Gt )
# 1636 "c/clparser.ml"
               : 'relation))
; (fun parser_env ->
    Obj.repr(
# 184 "c/clparser.mly"
          ( Le )
# 1642 "c/clparser.ml"
               : 'relation))
; (fun parser_env ->
    Obj.repr(
# 185 "c/clparser.mly"
          ( Ge )
# 1648 "c/clparser.ml"
               : 'relation))
; (fun parser_env ->
    Obj.repr(
# 186 "c/clparser.mly"
          ( Eq )
# 1654 "c/clparser.ml"
               : 'relation))
; (fun parser_env ->
    Obj.repr(
# 187 "c/clparser.mly"
          ( Neq )
# 1660 "c/clparser.ml"
               : 'relation))
; (fun parser_env ->
    Obj.repr(
# 191 "c/clparser.mly"
                ( [] )
# 1666 "c/clparser.ml"
               : 'lexpr_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ne_lexpr_list) in
    Obj.repr(
# 192 "c/clparser.mly"
                 ( _1 )
# 1673 "c/clparser.ml"
               : 'lexpr_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 196 "c/clparser.mly"
                           ( [_1] )
# 1680 "c/clparser.ml"
               : 'ne_lexpr_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'lexpr) in
    let _3 = (peek_val parser_env 0 : 'ne_lexpr_list) in
    Obj.repr(
# 197 "c/clparser.mly"
                            ( _1 :: _3 )
# 1688 "c/clparser.ml"
               : 'ne_lexpr_list))
; (fun parser_env ->
    Obj.repr(
# 201 "c/clparser.mly"
                ( None )
# 1694 "c/clparser.ml"
               : 'pre_condition))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 202 "c/clparser.mly"
                 ( Some _2 )
# 1701 "c/clparser.ml"
               : 'pre_condition))
; (fun parser_env ->
    Obj.repr(
# 206 "c/clparser.mly"
                 ( None )
# 1707 "c/clparser.ml"
               : 'post_condition))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 207 "c/clparser.mly"
                ( Some _2 )
# 1714 "c/clparser.ml"
               : 'post_condition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'pre_condition) in
    let _2 = (peek_val parser_env 2 : 'effects) in
    let _3 = (peek_val parser_env 1 : 'post_condition) in
    let _4 = (peek_val parser_env 0 : 'decreases) in
    Obj.repr(
# 212 "c/clparser.mly"
    ( { requires = _1; assigns = _2; ensures = _3; decreases = _4 } )
# 1724 "c/clparser.ml"
               : 'spec))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'invariant) in
    let _2 = (peek_val parser_env 1 : 'loop_effects) in
    let _3 = (peek_val parser_env 0 : 'variant) in
    Obj.repr(
# 217 "c/clparser.mly"
    ( { invariant = Some _1; loop_assigns = _2; variant = Some _3 } )
# 1733 "c/clparser.ml"
               : 'loop_annot))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'loop_effects) in
    let _2 = (peek_val parser_env 0 : 'variant) in
    Obj.repr(
# 219 "c/clparser.mly"
    ( { invariant = None; loop_assigns = _1; variant = Some _2 } )
# 1741 "c/clparser.ml"
               : 'loop_annot))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'invariant) in
    let _2 = (peek_val parser_env 0 : 'loop_effects) in
    Obj.repr(
# 221 "c/clparser.mly"
    ( { invariant = Some _1; loop_assigns = _2; variant = None } )
# 1749 "c/clparser.ml"
               : 'loop_annot))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ne_loop_effects) in
    Obj.repr(
# 223 "c/clparser.mly"
    ( { invariant = None; loop_assigns = Some _1; variant = None } )
# 1756 "c/clparser.ml"
               : 'loop_annot))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 227 "c/clparser.mly"
                  ( _2 )
# 1763 "c/clparser.ml"
               : 'invariant))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'lexpr) in
    let _4 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 231 "c/clparser.mly"
                               ( (_2, Some _4) )
# 1771 "c/clparser.ml"
               : 'variant))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 232 "c/clparser.mly"
                               ( (_2, None) )
# 1778 "c/clparser.ml"
               : 'variant))
; (fun parser_env ->
    Obj.repr(
# 236 "c/clparser.mly"
                  ( None )
# 1784 "c/clparser.ml"
               : 'decreases))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'variant) in
    Obj.repr(
# 237 "c/clparser.mly"
                    ( Some _2 )
# 1791 "c/clparser.ml"
               : 'decreases))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'annotation) in
    Obj.repr(
# 241 "c/clparser.mly"
                   ( _1 )
# 1798 "c/clparser.ml"
               : Cast.parsed_annot))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'decl) in
    Obj.repr(
# 245 "c/clparser.mly"
                   ( Adecl [_1] )
# 1805 "c/clparser.ml"
               : 'annotation))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ghost_decl) in
    Obj.repr(
# 246 "c/clparser.mly"
                   ( Adecl _1 )
# 1812 "c/clparser.ml"
               : 'annotation))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'spec) in
    Obj.repr(
# 247 "c/clparser.mly"
                   ( Aspec _1 )
# 1819 "c/clparser.ml"
               : 'annotation))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'loop_annot) in
    Obj.repr(
# 248 "c/clparser.mly"
                   ( Aloop_annot _1 )
# 1826 "c/clparser.ml"
               : 'annotation))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 249 "c/clparser.mly"
                   ( Acode_annot (Assert _2) )
# 1833 "c/clparser.ml"
               : 'annotation))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 250 "c/clparser.mly"
                   ( Acode_annot (Label _2) )
# 1840 "c/clparser.ml"
               : 'annotation))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : string) in
    let _4 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 252 "c/clparser.mly"
                   ( Acode_annot(GhostSet(_2,_4)) )
# 1848 "c/clparser.ml"
               : 'annotation))
; (fun parser_env ->
    Obj.repr(
# 256 "c/clparser.mly"
                ( None )
# 1854 "c/clparser.ml"
               : 'effects))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'locations) in
    Obj.repr(
# 257 "c/clparser.mly"
                    ( Some _2 )
# 1861 "c/clparser.ml"
               : 'effects))
; (fun parser_env ->
    Obj.repr(
# 258 "c/clparser.mly"
                  ( Some [] )
# 1867 "c/clparser.ml"
               : 'effects))
; (fun parser_env ->
    Obj.repr(
# 262 "c/clparser.mly"
                ( None )
# 1873 "c/clparser.ml"
               : 'loop_effects))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ne_loop_effects) in
    Obj.repr(
# 263 "c/clparser.mly"
                  ( Some _1 )
# 1880 "c/clparser.ml"
               : 'loop_effects))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'locations) in
    Obj.repr(
# 267 "c/clparser.mly"
                         ( _2 )
# 1887 "c/clparser.ml"
               : 'ne_loop_effects))
; (fun parser_env ->
    Obj.repr(
# 268 "c/clparser.mly"
                       ( [] )
# 1893 "c/clparser.ml"
               : 'ne_loop_effects))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'location) in
    Obj.repr(
# 272 "c/clparser.mly"
           ( [_1] )
# 1900 "c/clparser.ml"
               : 'locations))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'location) in
    let _3 = (peek_val parser_env 0 : 'locations) in
    Obj.repr(
# 273 "c/clparser.mly"
                           ( _1 :: _3 )
# 1908 "c/clparser.ml"
               : 'locations))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 277 "c/clparser.mly"
        ( _1 )
# 1915 "c/clparser.ml"
               : 'location))
; (fun parser_env ->
    let _2 = (peek_val parser_env 4 : 'logic_type) in
    let _3 = (peek_val parser_env 3 : string) in
    let _5 = (peek_val parser_env 1 : 'parameters) in
    Obj.repr(
# 282 "c/clparser.mly"
    ( LDlogic (Info.default_logic_info _3, _2, _5, []) )
# 1924 "c/clparser.ml"
               : 'decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 6 : 'logic_type) in
    let _3 = (peek_val parser_env 5 : string) in
    let _5 = (peek_val parser_env 3 : 'parameters) in
    let _8 = (peek_val parser_env 0 : 'locations) in
    Obj.repr(
# 284 "c/clparser.mly"
    ( LDlogic (Info.default_logic_info _3, _2, _5, _8) )
# 1934 "c/clparser.ml"
               : 'decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 3 : string) in
    let _4 = (peek_val parser_env 1 : 'parameters) in
    Obj.repr(
# 286 "c/clparser.mly"
    ( LDpredicate_reads (Info.default_logic_info _2, _4, []) )
# 1942 "c/clparser.ml"
               : 'decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 5 : string) in
    let _4 = (peek_val parser_env 3 : 'parameters) in
    let _7 = (peek_val parser_env 0 : 'locations) in
    Obj.repr(
# 288 "c/clparser.mly"
    ( LDpredicate_reads (Info.default_logic_info _2, _4, _7) )
# 1951 "c/clparser.ml"
               : 'decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 6 : string) in
    let _4 = (peek_val parser_env 4 : 'parameters) in
    let _7 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 290 "c/clparser.mly"
    ( LDpredicate_def (Info.default_logic_info _2, _4, _7) )
# 1960 "c/clparser.ml"
               : 'decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : string) in
    let _4 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 291 "c/clparser.mly"
                               ( LDaxiom (_2, _4) )
# 1968 "c/clparser.ml"
               : 'decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : string) in
    let _4 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 292 "c/clparser.mly"
                                   ( LDinvariant (_2, _4) )
# 1976 "c/clparser.ml"
               : 'decl))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'logic_type) in
    let _3 = (peek_val parser_env 0 : 'init_declarator_list) in
    Obj.repr(
# 297 "c/clparser.mly"
      ( List.map (ghost _2) _3 )
# 1984 "c/clparser.ml"
               : 'ghost_decl))
; (fun parser_env ->
    Obj.repr(
# 301 "c/clparser.mly"
                 ( [] )
# 1990 "c/clparser.ml"
               : 'parameters))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'ne_parameters) in
    Obj.repr(
# 302 "c/clparser.mly"
                ( _1 )
# 1997 "c/clparser.ml"
               : 'parameters))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'parameter) in
    Obj.repr(
# 306 "c/clparser.mly"
            ( [_1] )
# 2004 "c/clparser.ml"
               : 'ne_parameters))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'parameter) in
    let _3 = (peek_val parser_env 0 : 'ne_parameters) in
    Obj.repr(
# 307 "c/clparser.mly"
                                ( _1 :: _3 )
# 2012 "c/clparser.ml"
               : 'ne_parameters))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'logic_type) in
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 311 "c/clparser.mly"
                        ( (_1, _2) )
# 2020 "c/clparser.ml"
               : 'parameter))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'logic_type) in
    let _2 = (peek_val parser_env 2 : string) in
    Obj.repr(
# 312 "c/clparser.mly"
                                        ( (LTarray _1, _2) )
# 2028 "c/clparser.ml"
               : 'parameter))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr(
# 319 "c/clparser.mly"
                          ( [_1] )
# 2035 "c/clparser.ml"
               : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'init_declarator_list) in
    let _3 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr(
# 320 "c/clparser.mly"
                                                     ( _1 @ [_3] )
# 2043 "c/clparser.ml"
               : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr(
# 325 "c/clparser.mly"
            ( let (id,d) = _1 in (id,d, None) )
# 2050 "c/clparser.ml"
               : 'init_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr(
# 327 "c/clparser.mly"
     ( let (id,d) = _1 in (id,d, Some _3) )
# 2058 "c/clparser.ml"
               : 'init_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'direct_declarator) in
    Obj.repr(
# 332 "c/clparser.mly"
                              ( _1 )
# 2065 "c/clparser.ml"
               : 'declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr(
# 337 "c/clparser.mly"
            ( _1, Dsimple )
# 2072 "c/clparser.ml"
               : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _3 = (peek_val parser_env 1 : 'lexpr) in
    Obj.repr(
# 339 "c/clparser.mly"
     ( let id,d = _1 in id, Darray (d, Some _3) )
# 2080 "c/clparser.ml"
               : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_declarator) in
    Obj.repr(
# 341 "c/clparser.mly"
     ( let id,d = _1 in id, Darray (d, None) )
# 2087 "c/clparser.ml"
               : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'lexpr) in
    Obj.repr(
# 345 "c/clparser.mly"
                ( Iexpr _1 )
# 2094 "c/clparser.ml"
               : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'c_initializer_list) in
    Obj.repr(
# 346 "c/clparser.mly"
                                           ( Ilist _2 )
# 2101 "c/clparser.ml"
               : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'c_initializer_list) in
    Obj.repr(
# 347 "c/clparser.mly"
                                                 ( Ilist _2 )
# 2108 "c/clparser.ml"
               : 'c_initializer))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr(
# 351 "c/clparser.mly"
                        ( [_1] )
# 2115 "c/clparser.ml"
               : 'c_initializer_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'c_initializer_list) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr(
# 352 "c/clparser.mly"
                                                 ( _1 @ [_3] )
# 2123 "c/clparser.ml"
               : 'c_initializer_list))
(* Entry annot *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error;
    names_const=yynames_const;
    names_block=yynames_block }
let annot (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf : Cast.parsed_annot)
;;
